<?php
namespace EMS\PortalFuncionario\Geral\Controllers;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DataSource\DataSet;
use Doctrine\ORM\EntityManager;

use EMS\PortalFuncionario\Geral\Services\EstruturaService;

class EstruturaController {

    public function __construct(EntityManager $entityManager, EstruturaService $estruturaService) {
        $this->entityManager            = $entityManager;
        $this->estruturaService         = $estruturaService;
    }

    public function getPontoAcesso(DTO\Request\Filter $request, DTO\Response $response) {
        try {
            $params = $request->getParameters();
            $pontoAcesso = $this->estruturaService->getPontoAcesso(
                $params['NRORG'],
                $params['NRVINCULOM']
            );
            $response->addDataSet(new DataSet('pontoAcesso', $pontoAcesso));
        } catch (\Exception $e) {
            $response->addMessage(new DTO\Response\Message($e->getMessage(), DTO\Response\Message::TYPE_ERROR));
        }
    }
}