#!/bin/bash

SCRIPTS_PATH=$('pwd')
MCSV_PATH=$('pwd')/../
DEVOPS_VERSION="0"
DEVOPS_REVISION="23"
DEVOPS_BUILD="0"
PACKAGE_VERSION="$DEVOPS_VERSION.$DEVOPS_REVISION.$DEVOPS_BUILD"
REVISION_DATE=$(date +%s)

echo 'Verificando NPM_TOKEN -------------------------------------------'
cd ~

echo 'Atualizando token ---------------'
$SCRIPTS_PATH/replace.sh '80a1b754-5234-4618-97e4-4449de82709a' '76f8066c-539b-47b8-8a76-4af6ceb8c20f' '~/.profile'

if ! grep -q NPM_TOKEN "~/.profile"; then
  echo 'Adicionando NPM_TOKEN.'
  echo 'export NPM_TOKEN="76f8066c-539b-47b8-8a76-4af6ceb8c20f"' >> ~/.profile
else
	echo 'NPM_TOKEN já adicionado.'
fi

cat ~/.profile

echo 'Verificando .npmrc -----------------------------------------------'
if ! test -f './.npmrc'; then
	echo 'Criando arquivo .npmrc'
    echo '//registry.npmjs.org/:_authToken=${NPM_TOKEN}' > ./.npmrc
else
	echo 'Arquivo .npmrc já criado'
fi

cat ./.npmrc

echo 'Front Step --------------------------------------------------------------'
cd $MCSV_PATH/mobile
#rm -v ./.npmrc
$SCRIPTS_PATH/front_step.sh

echo 'Run Grunt Tasks For Production -------------------------------------------'
grunt init_project
grunt buildEnvironment:production

echo 'Update Package Version Constants.ts ----------------------------------------------------'
cd $MCSV_PATH/mobile/src/assets/ts/configuration/
$SCRIPTS_PATH/replace.sh "<>PRODUCT_VERSION<>" $PACKAGE_VERSION "Constants.ts"

#echo 'Updating version..........................................................'
#cd $MCSV_PATH/
#$SCRIPTS_PATH/replace.sh "0.0.0" $PACKAGE_VERSION "productInfo.json"
#cat ./productInfo.json

echo 'Building application frontend ---------------------------------------------'
cd $MCSV_PATH/mobile
{
    source ~/.profile
    source ~/.profile
    npm run build
} || {
   echo 'Build Error ---------------------------------------------------------------'
   exit 1
}

echo 'Back Step --------------------------------------------------------------'
cd $MCSV_PATH/backend
rm -v index.php
$SCRIPTS_PATH/back_step.sh $DEVOPS_VERSION $DEVOPS_REVISION $DEVOPS_BUILD

echo 'Update Package Version ---------------------------------------------------'
cd $MCSV_PATH/backend/config
$SCRIPTS_PATH/replace.sh "<>APPLICATION_VERSION<>" $PACKAGE_VERSION "parameters.xml"

echo 'Remove Development Dependencies ------------------------------------------'
rm -f $MCSV_PATH/mobile/.bowerrc
rm -f $MCSV_PATH/mobile/bower.json
rm -f $MCSV_PATH/mobile/GruntFile.js
rm -f $MCSV_PATH/README.md

#rm -Rf $MCSV_PATH/mobile/node_modules
rm -Rf $MCSV_PATH/mobile/config

cd $MCSV_PATH
mv mobile/ mobile_delete/
mkdir mobile/
mv mobile_delete/dist/* mobile/
mv mobile_delete/assets mobile/
rm -Rf mobile_delete

echo 'Remove all .git folders --------------------------------------------------'
cd $SCRIPTS_PATH/../
#find . -name .git -exec rm -rf {} +

echo 'Create modules folder ----------------------------------------------------'
cd $MCSV_PATH
rm -Rf ./modules
mkdir -p ./modules/
mkdir -p ./modules/teknisa

echo 'COMPOSER DUMP-AUTOLOAD -----------------------------------'
cd $MCSV_PATH/backend/
composer dump-autoload
